% ====================
% =   start symbol   =
% ====================

start(r).

% ====================
% =   nonterminals   =
% ====================

nonterminal(s(_,_)).
nonterminal(t(_,_,_,_)).

% ====================
% =     terminals    =
% ====================

terminal(a(_,_)).
terminal(a_l(_,_)).
terminal(a_r(_,_)).
terminal(b(_,_)).
terminal(b_l(_,_)).
terminal(b_r(_,_)).

% ====================
% = hyperedge labels =
% ====================

hyperedge_labels(r).
hyperedge_labels(l(f-1)).
hyperedge_labels(r(t-1)).
hyperedge_labels(s(f-1,t-2)).
hyperedge_labels(t(f-1,f-2,t-3,t-4)).
hyperedge_labels(a(f-1,t-2)).
hyperedge_labels(a_l(f-1,t-2)).
hyperedge_labels(a_r(f-1,t-2)).
hyperedge_labels(b(f-1,t-2)).
hyperedge_labels(b_l(f-1,t-2)).
hyperedge_labels(b_r(f-1,t-2)).

% ====================
% =       rules      =
% ====================

rule(r, [s(X,Y)], [l(X),r(Y)]).
rule(s(X1,X), [s(X2,X3),s(X4,X)], [a_l(X1,X2),a(X3,X4)]).
rule(s(X1,X), [s(X4,X)], [a_l(X1,X2),a(X2,X4)]).
rule(s(X1,X), [s(X2,X3)], [a_l(X1,X2),a(X3,X)]).
rule(s(X1,X), [], [a_l(X1,X2),a(X2,X)]).
rule(s(X1,X), [s(X2,X3),s(X4,X)], [b_l(X1,X2),b(X3,X4)]).
rule(s(X1,X), [s(X4,X)], [b_l(X1,X2),b(X2,X4)]).
rule(s(X1,X), [s(X2,X3)], [b_l(X1,X2),b(X3,X)]).
rule(s(X1,X), [], [b_l(X1,X2),b(X2,X)]).
rule(s(X1,X), [s(X2,X3),s(X4,X)], [a(X1,X2),a_r(X3,X4)]).
rule(s(X1,X), [s(X4,X)], [a(X1,X2),a_r(X2,X4)]).
rule(s(X1,X), [s(X2,X3)], [a(X1,X2),a_r(X3,X)]).
rule(s(X1,X), [], [a(X1,X2),a_r(X2,X)]).
rule(s(X1,X), [s(X2,X3),s(X4,X)], [b(X1,X2),b_r(X3,X4)]).
rule(s(X1,X), [s(X4,X)], [b(X1,X2),b_r(X2,X4)]).
rule(s(X1,X), [s(X2,X3)], [b(X1,X2),b_r(X3,X)]).
rule(s(X1,X), [], [b(X1,X2),b_r(X2,X)]).

% ====================
% =  example graphs  =
% ====================

example(1, [l(0),r(2),a_l(0,1),a(1,2)]).
example(2, [l(0),r(2),a(0,1),a_r(1,2)]).
example(3, [l(0),r(6),a_l(0,1),a_l(1,2),a(2,3),a(3,4),a(4,5),a_r(5,6)]).
