% ====================
% =   start symbol   =
% ====================

start(s).

% ====================
% =   nonterminals   =
% ====================

nonterminal(s).
nonterminal(a(_,_,_)).

% ====================
% =     terminals    =
% ====================

terminal(b(_,_)).

% ====================
% = hyperedge labels =
% ====================

hyperedge_labels(s).
hyperedge_labels(a(t-1,f-2,f-3)).
hyperedge_labels(b(t-1,f-2)).

% ====================
% =       rules      =
% ====================

rule(s, [a(_,Y,Z)], [b(Y,Z)]).
rule(a(X,Y,Z), [a(X,Y,V)], [b(X,Z),b(Z,V)]).
rule(a(X,Y,Z), [], [b(X,Y),b(X,Z),b(Y,Z)]).

% ====================
% =  example graphs  =
% ====================

example(1, [b(1,2),b(1,3),b(2,3)]).
example(2, [b(1,2),b(1,3),b(1,4),b(2,3),b(3,4),b(4,2)]).

%       5
%     / | \
%   /   |   \
% 2 --- 1 --- 4
%   \   |   /
%     \ | /
%       3

example(3, [b(1,2),b(1,3),b(1,4),b(1,5),b(2,3),b(3,4),b(4,5),b(5,2)]).

